Debian Bug report logs - #620993
general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing

Package: general; Maintainer for general is debian-devel@lists.debian.org;

Reported by: Daniel Gary <dgary1980@gmail.com>

Date: Tue, 5 Apr 2011 18:21:02 UTC

Severity: normal

Done: Ben Hutchings <ben@decadent.org.uk>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org:
Bug#620993; Package general. (Tue, 05 Apr 2011 18:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Gary <dgary1980@gmail.com>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org. (Tue, 05 Apr 2011 18:21:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Daniel Gary <dgary1980@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing
Date: Tue, 05 Apr 2011 11:08:45 -0700
Package: general
Severity: normal


Swap usage prior to 2.6.26-2 upgrade was a relatively constant 0
Post 2.6.26-2 upgrade the usage is usually up into 300MB, not actively swapping however and doesn't seem to be affecting performance, but nagios is none to happy about swap being used.
The problem seems relegated to a handful of machines, although there may be some usage pattern I'm not seeing but otherwise there is no difference between systems that are "swap happy" and those where swap stays 0, same make/model, same build configuration, packages, client code, etc.

Like I mentioned, it doesn't seem to impact performance, but it is certainly a change from the norm.
See this on about 8 systems out of a couple hundred, and the same 8 will almost always start using swap slowly over time until a plateu is reached of around 300-500MB, depending on the system.


-- System Information:
Debian Release: 5.0.8
  APT prefers oldstable
  APT policy: (500, 'oldstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.26-2-amd64 (SMP w/8 CPU cores)
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)
Shell: /bin/sh linked to /bin/bash




Reply sent to Ben Hutchings <ben@decadent.org.uk>:
You have taken responsibility. (Tue, 05 Apr 2011 18:48:03 GMT) Full text and rfc822 format available.

Notification sent to Daniel Gary <dgary1980@gmail.com>:
Bug acknowledged by developer. (Tue, 05 Apr 2011 18:48:03 GMT) Full text and rfc822 format available.

Message #10 received at 620993-done@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: 620993-done@bugs.debian.org
Subject: Re: Bug#620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing
Date: Tue, 5 Apr 2011 19:45:28 +0100
On Tue, Apr 05, 2011 at 11:08:45AM -0700, Daniel Gary wrote:
> Package: general
> Severity: normal
> 
> 
> Swap usage prior to 2.6.26-2 upgrade was a relatively constant 0
> Post 2.6.26-2 upgrade the usage is usually up into 300MB, not actively swapping however and doesn't seem to be affecting performance, but nagios is none to happy about swap being used.

Then fix the NAGIOS configuration.

Ben.

-- 
Ben Hutchings
We get into the habit of living before acquiring the habit of thinking.
                                                              - Albert Camus




Information forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org:
Bug#620993; Package general. (Tue, 05 Apr 2011 19:15:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Gary <dgary1980@gmail.com>:
Extra info received and forwarded to list. Copy sent to debian-devel@lists.debian.org. (Tue, 05 Apr 2011 19:15:07 GMT) Full text and rfc822 format available.

Message #15 received at 620993@bugs.debian.org (full text, mbox):

From: Daniel Gary <dgary1980@gmail.com>
To: 620993@bugs.debian.org
Subject: Re: Bug#620993 closed by Ben Hutchings <ben@decadent.org.uk> (Re: Bug#620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing)
Date: Tue, 05 Apr 2011 12:15:12 -0700
I have, but fixing monitoring to suit edge cases created from a recent 
upgrade doesn't make the edge cases non-issues.

This is still an issue whether you want to hide it under nagios or not, 
so I'd appreciate a little more assistance in finding the problem beyond 
"fixing nagios".
If you go the doctors for a broken leg he doesn't just tell you "well 
try not to walk on it".

The upgrades to 2.6.26-2 created anomalies, anomalies are bad.


On 4/5/2011 11:48 AM, Debian Bug Tracking System wrote:
> This is an automatic notification regarding your Bug report
> which was filed against the general package:
>
> #620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing
>
> It has been closed by Ben Hutchings<ben@decadent.org.uk>.
>
> Their explanation is attached below along with your original report.
> If this explanation is unsatisfactory and you have not received a
> better one in a separate message then please contact Ben Hutchings<ben@decadent.org.uk>  by
> replying to this email.
>
>





Information forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org:
Bug#620993; Package general. (Tue, 05 Apr 2011 21:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Danjean <vdanjean@debian.org>:
Extra info received and forwarded to list. Copy sent to debian-devel@lists.debian.org. (Tue, 05 Apr 2011 21:15:34 GMT) Full text and rfc822 format available.

Message #20 received at 620993@bugs.debian.org (full text, mbox):

From: Vincent Danjean <vdanjean@debian.org>
To: 620993@bugs.debian.org, dgary1980@gmail.com
Subject: Re: Bug#620993: closed by Ben Hutchings <ben@decadent.org.uk> (Re: Bug#620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing)
Date: Tue, 05 Apr 2011 22:45:53 +0200
On 05/04/2011 21:15, Daniel Gary wrote:
> I have, but fixing monitoring to suit edge cases created from a recent upgrade
> doesn't make the edge cases non-issues.
> 
> This is still an issue whether you want to hide it under nagios or not,

I do not understand the issue. You have some swap and you expect the
kernel *not* to use it ? *This* would be a bug. It is better that the
kernel swap out (parts of) processes it never uses and keep the RAM for
processes that need it.

  Regards,
    Vincent





Information forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org:
Bug#620993; Package general. (Tue, 05 Apr 2011 21:27:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Gary <dgary1980@gmail.com>:
Extra info received and forwarded to list. Copy sent to debian-devel@lists.debian.org. (Tue, 05 Apr 2011 21:27:08 GMT) Full text and rfc822 format available.

Message #25 received at 620993@bugs.debian.org (full text, mbox):

From: Daniel Gary <dgary1980@gmail.com>
To: Vincent Danjean <vdanjean@debian.org>
Cc: 620993@bugs.debian.org
Subject: Re: Bug#620993: closed by Ben Hutchings <ben@decadent.org.uk> (Re: Bug#620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing)
Date: Tue, 05 Apr 2011 14:17:49 -0700
I'm not arguing that, I fully expect the kernel to use it to swap *if 
needed*.
And if this was 20MB of swap, or maybe 100MB, ok, sure, the kernel might 
be swapping old pages out, but 300MB+ swapping out in 2.6.26-2 where 0MB 
swapped out in 2.6.26-1, and I can't find anything in the kernel.org or 
debian kernel changelogs referencing a change along these lines doesn't 
really scream "working as expected".
More annoying that the swap space never decreases unless swapoff/swapon 
occurs

The closest thing I can find was a patch from Mel Gorman, but that 
doesn't explain how the swap space is getting used in the first place, 
or more how 2 otherwise identical machines have different amounts used, 
0 and in the case I'm debugging ATM 312MB, Same make/model, same debian 
lenny build, they're clones for all intents and purposes.

The only thing on these systems that has changed was 2.6.26-1 to 
2.6.26-2, and swap wasn't being used to this extent, or staying used if 
it was used, prior to 2.6.26-2.
Now it almost seems that once its used it doesn't get freed.

On 4/5/2011 1:45 PM, Vincent Danjean wrote:
> On 05/04/2011 21:15, Daniel Gary wrote:
>> I have, but fixing monitoring to suit edge cases created from a recent upgrade
>> doesn't make the edge cases non-issues.
>>
>> This is still an issue whether you want to hide it under nagios or not,
> I do not understand the issue. You have some swap and you expect the
> kernel *not* to use it ? *This* would be a bug. It is better that the
> kernel swap out (parts of) processes it never uses and keep the RAM for
> processes that need it.
>
>    Regards,
>      Vincent
>
>





Information forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org:
Bug#620993; Package general. (Tue, 05 Apr 2011 21:57:19 GMT) Full text and rfc822 format available.

Acknowledgement sent to russell@coker.com.au:
Extra info received and forwarded to list. Copy sent to debian-devel@lists.debian.org. (Tue, 05 Apr 2011 21:57:26 GMT) Full text and rfc822 format available.

Message #30 received at 620993@bugs.debian.org (full text, mbox):

From: Russell Coker <russell@coker.com.au>
To: debian-devel@lists.debian.org, Daniel Gary <dgary1980@gmail.com>, 620993@bugs.debian.org
Subject: Re: Bug#620993: closed by Ben Hutchings <ben@decadent.org.uk> (Re: Bug#620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing)
Date: Wed, 6 Apr 2011 07:47:09 +1000
On Wed, 6 Apr 2011, Daniel Gary <dgary1980@gmail.com> wrote:
> I'm not arguing that, I fully expect the kernel to use it to swap *if 
> needed*.
> And if this was 20MB of swap, or maybe 100MB, ok, sure, the kernel might 
> be swapping old pages out, but 300MB+ swapping out in 2.6.26-2 where 0MB 

Using more memory for disk cache and less for storing rarely used pages sounds 
like a performance optimisation.

Anyway I don't think that there's going to be much interest in performance-
tuning of Lenny kernels now that Squeeze is released.

If you want help in tuning Lenny then probably debian-user or your local LUG 
mailing list would be the best option.

-- 
My Main Blog         http://etbe.coker.com.au/
My Documents Blog    http://doc.coker.com.au/




Information forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org:
Bug#620993; Package general. (Tue, 05 Apr 2011 22:18:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Gary <dgary1980@gmail.com>:
Extra info received and forwarded to list. Copy sent to debian-devel@lists.debian.org. (Tue, 05 Apr 2011 22:18:10 GMT) Full text and rfc822 format available.

Message #35 received at 620993@bugs.debian.org (full text, mbox):

From: Daniel Gary <dgary1980@gmail.com>
To: russell@coker.com.au
Cc: debian-devel@lists.debian.org, 620993@bugs.debian.org
Subject: Re: Bug#620993: closed by Ben Hutchings <ben@decadent.org.uk> (Re: Bug#620993: general: Lenny 2.6.26-2 has noticably increased swap usage, tho not swap thrashing)
Date: Tue, 05 Apr 2011 15:17:52 -0700
On 4/5/2011 2:47 PM, Russell Coker wrote:
> On Wed, 6 Apr 2011, Daniel Gary<dgary1980@gmail.com>  wrote:
>> I'm not arguing that, I fully expect the kernel to use it to swap *if
>> needed*.
>> And if this was 20MB of swap, or maybe 100MB, ok, sure, the kernel might
>> be swapping old pages out, but 300MB+ swapping out in 2.6.26-2 where 0MB
> Using more memory for disk cache and less for storing rarely used pages sounds
> like a performance optimisation.
Fully agree, but I don't see anything in the changelog where that 
optimization occurred. So while it sounds great in theory I can't back 
it with the patches that went into 2.6.26-2 from 2.6.26-1.
Although it is what I've been telling the client is the likely case for 
lack of a better answer and no loss in performance on the system.
> Anyway I don't think that there's going to be much interest in performance-
> tuning of Lenny kernels now that Squeeze is released.
Unfortunately an upgrade to Squeeze is a bit more involved than the 
upgrade windows we have available, but I think may be the only option at 
this point, but that's kind of like fixing a sparkplug that doesn't fire 
by buying a new car, sure it'll probably do the job in the end, but that 
doesn't really explain why the sparkplug doesn't fire.
But certainly a better reason to close the ticket than the previous one, 
doesn't make it invalid, just makes it a wontfix.
I'd rather it be closed for someone being lazy than someone being 
dismissive, a good sysadmin is a lazy sysadmin after all.

> If you want help in tuning Lenny then probably debian-user or your local LUG
> mailing list would be the best option.
>
Its not a tuning issue, its a change in a vacuum, more a freakish 
annoyance than anything, it performs fine, we benchmarked before & after 
and didn't notice any change either way other than these systems that 
swap, well... swap.
The support tech in me says "screw it, it works", but the engineer in me 
says "hmm, thats funny".




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 04 May 2011 07:40:44 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 21:26:07 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.